#ifndef _ABB_H_
#define _ABB_H_

typedef int Tipo;

typedef struct abb {
  struct abb *esq;
  Tipo info;
  struct abb *dir;
} abb;

void inicializar(abb **raiz);
abb *pesquisar(abb *raiz, Tipo elem);
abb *pesquisarIterativo(abb *raiz, Tipo elem);
abb *pesquisarMinimo(abb *raiz);
abb *pesquisarMinimoIterativo(abb *raiz);
abb *pesquisarMaximo(abb *raiz);
abb *pesquisarMaximoIterativo(abb *raiz);
int inserir(abb **raiz, Tipo valor);
void remover(abb **raiz, int elem);
void emOrdem (abb *raiz);
void preOrdem (abb *raiz);
void posOrdem (abb *raiz);
void porNivel (abb *raiz);
int qtdElementos(abb *raiz);
int altura(abb *raiz);
int qtdPares(abb *raiz);
int qtdImpares(abb *raiz);
int somaNivel(abb *raiz, int nivel);
int mesmaEstrutura(abb *raiz);

#endif // _ABB_H_