#include <stdio.h>
#include <stdlib.h>
#include "fila.h"

void insFila(struct Fila **f, abb *v)
{
	struct Fila *aux1 = (struct Fila *) malloc(sizeof(struct Fila)), *aux2;
	aux1->valor = v;
	aux1->prox = NULL;
	if (*f == NULL)
	{
		*f = aux1;
	}
	else
	{
		aux2 = *f;
		while (aux2->prox != NULL)
			aux2 = aux2->prox;
		aux2->prox = aux1;
	}
}

abb *remFila(struct Fila **f)
{
	struct Fila *aux;
	abb *resp;
	if (*f == NULL)
	{
		printf("Erro! Fila vazia!\n");
		system("pause");
		exit(1);
	}
	aux = *f;
	resp = aux->valor;
	*f = aux->prox;
	free(aux);
	return resp;
}
